/*
 *      _ L I S T _ F i f o L a s t
 *
 *  This is a support function.   It is used to
 *  find the last function for a linked list type 
 *  that DOES maintain a pointer to the last 
 *  node (such as out implementation of a FIFO).
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */


#include <liblist.h>
#include "liblistx.h"


extern
node_t  _LIST_FifoLast      (list_t list)
{
#ifdef LIBTEST
	register _fifoh_t fifolist = (_fifoh_t)list;
#else
#define fifolist ((_fifoh_t)list)
#endif

    register _fifo_t  fifonode;

    fifonode = fifolist->last;
    /*
     *  If the list is empty, we
     *  must return a NULL value.
     */
    if (fifonode != NULL)
    {
        fifonode = _LIST_USERNODE(fifolist,fifonode);
    }
    return (node_t)fifonode;
}

