/*
 *      _ L I S T _ F i f o R e m o v e
 *
 *  This is used to remove a node from a 
 *  singled linked list that DOES have
 *  a pointer to the last node.
 *
 *	These are:
 *		- FIFO
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  23 May 96   DJW   - First version
 *
 *	09 May 99	DJW	  -	Updated to use the new '_LIST_ListRemove' support routine.
 */


#include <liblist.h>
#include "liblistx.h"


int     _LIST_FifoRemove (list_t list, node_t node)
{
	/*
	 *	If TESTING is defined assign parameters to
	 *	local variables to help with debugging
	 */
#ifdef TESTING
	_fifoh_t	fifolist = (_fifoh_t)list;
	_fifo_t		fifonode = (fifo_t)node;
#else
#define fifolist   ((_fifoh_t)list)
#define fifonode  ((_fifo_t)node)
#endif /* TESTING */

    _fifo_t listnode = NULL;

	listnode = (_fifo_t)_LIST_ListRemove(list, node);
	if ((long)listnode < 0)
	{
		return (int)((long)listnode);
	}
    /*
	 * If this was the last node, then
	 * we had better set that as well.
	 */
    if (fifolist->last == fifonode)
    {
        LIBASSERT (fifonode->next == NULL)
        fifolist->last = listnode;
    }
    return (LIST_ERROR_NONE);
}
