/*
 *      L I S T  _ F i n d
 *
 *  This function is called when it is required
 *  to find a specific node.
 *
 *  Returns:
 *      -ve     Error occurred
 *      0       Not found
 *      +ve     Pointer to node found
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */


#include <liblist.h>
#include "liblistx.h"


node_t  LIST_Find (list_t list, int (*findfunc)(node_t, va_list), ...)
{
    va_list ap;
    node_t  node;


    /*
     *  The user has supplied a 'find'
     *  routine, so call the list type
     *  specific routine.
     */
    va_start (ap, findfunc);
    node = list->listclass->master->find(list,findfunc,ap);
    va_end (ap);
    return (node);
}

