/*
 *      L I S T _ P e e k
 *
 *  This function is called when it is required
 *  to look at the node that would be removed
 *  by a dequeue or pop operation without
 *  actually doing the remove.
 *
 *
 * (c) Copyright 1996-1999 David J. Walker
 *     Email:  dave.walker@icl.com
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  22 May 96   DJW   - First version
 */


#include <liblist.h>
#include "liblistx.h"


node_t  LIST_Peek (list_t list)
{
    LIBDEBUG ("LIST_Peek", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListCheck(list))

    return LIST_First(list);
}

